import os
from pyowm.owm import OWM
from openai import OpenAI
from datetime import datetime

number_map = {
    "0": "zero",
    "1": "one",
    "2": "two",
    "3": "three",
    "4": "four",
    "5": "six",
    "6": "six",
    "7": "seven",
    "8": "eight",
    "9": "nine",
    "10": "ten",
    "11": "eleven",
    "12": "twelve",
    "13": "thirteen",
    "14": "fourteen",
    "15": "fifteen",
    "16": "sixteen",
    "17": "seventeen",
    "18": "eighteen",
    "19": "nineteen",
    "20": "twenty",
    "30": "thirty",
    "40": "forty",
    "50": "fifty",
}


def serialize_time_part(part):
    part_string = ""
    if part in number_map:
        part_string += number_map[part]
    else:
        tens_str = number_map[f"{part[0]}0"]
        ones_str = number_map[part[1]]
        part_string += f"{tens_str}-{ones_str}"
    return part_string


def serialize_time(time):
    hour = str(time.hour)
    if time.hour > 12:
        hour = str(time.hour - 12)
    hour = serialize_time_part(hour)
    minute = str(time.minute)
    if time.minute < 10:
        minute = f"o'{serialize_time_part(minute)}"
    else:
        minute = serialize_time_part(minute)
    time_string = f"{hour} {minute}"
    return time_string


def generate_rhyme(time):
    client = OpenAI()
    response = client.chat.completions.create(
        model="gpt-4",
        messages=[
            {
                "role": "user",
                "content": f"Finish this sentence about the time with a rhyme. It's {time}, ",
            }
        ],
    )
    rhyme = response.choices[0].message.content
    return f"It's {time} {rhyme}"


def get_weather():
    pass


def main():
    use_time = datetime.now()
    serialized_time = serialize_time(use_time)
    print(serialized_time)
    sentence = generate_rhyme(serialized_time)
    weather = get_weather()

    print(sentence)
    print(weather)


if __name__ == "__main__":
    main()
